diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/test/global-route-manager-impl-test-suite.cc ns-3.47/src/internet/test/global-route-manager-impl-test-suite.cc
--- ns-3.46/src/internet/test/global-route-manager-impl-test-suite.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/test/global-route-manager-impl-test-suite.cc	2026-02-16 16:08:49.623230000 -0800
@@ -810,7 +1300,165 @@
     lsa3->AddLinkRecord(lr13);
     lsa3->AddLinkRecord(lr14);
     lsa3->AddLinkRecord(lr15);
-    m_lsas.push_back(lsa3);
+    m_lsasv4.push_back(lsa3);
+}
+
+void
+RandomEcmpTestCase::BuildLsav6()
+{
+    // we manually create the link state database, we could have used BuildRoutingTables() but this
+    // way testing the GlobalRouteManagerImpl without the involvement of GLobalRouter makes it
+    // easier to debug each individually
+
+    // router 0
+    auto lr0 =
+        new GlobalRoutingLinkRecord<Ipv6Manager>(GlobalRoutingLinkRecord<Ipv6Manager>::PointToPoint,
+                                                 "::ffff:0.0.0.1",
+                                                 "2001:1::200:ff:fe00:1",
+                                                 "fe80::200:ff:fe00:1",
+                                                 1);
+    // only need to do this once for prefix of 64 bits
+    uint8_t buf[16];
+    auto prefix = Ipv6Prefix(64);
+    prefix.GetBytes(buf); // frown
+
+    auto lr1 =
+        new GlobalRoutingLinkRecord<Ipv6Manager>(GlobalRoutingLinkRecord<Ipv6Manager>::StubNetwork,
+                                                 "2001:1::200:ff:fe00:2",
+                                                 Ipv6Address(buf),
+                                                 1);
+    auto lr2 =
+        new GlobalRoutingLinkRecord<Ipv6Manager>(GlobalRoutingLinkRecord<Ipv6Manager>::PointToPoint,
+                                                 "::ffff:0.0.0.2",
+                                                 "2001:2::200:ff:fe00:5",
+                                                 "fe80::200:ff:fe00:5",
+                                                 1);
+    auto lr3 =
+        new GlobalRoutingLinkRecord<Ipv6Manager>(GlobalRoutingLinkRecord<Ipv6Manager>::StubNetwork,
+                                                 "2001:2::200:ff:fe00:6",
+                                                 Ipv6Address(buf),
+                                                 1);
+
+    auto lsa0 = new GlobalRoutingLSA<Ipv6Manager>();
+    lsa0->SetLSType(GlobalRoutingLSA<Ipv6Manager>::RouterLSA);
+    lsa0->SetStatus(GlobalRoutingLSA<Ipv6Manager>::LSA_SPF_NOT_EXPLORED);
+    lsa0->SetLinkStateId("::ffff:0.0.0.0");
+    lsa0->SetAdvertisingRouter("::ffff:0.0.0.0");
+    lsa0->SetNode(nodes.Get(0));
+    lsa0->AddLinkRecord(lr0);
+    lsa0->AddLinkRecord(lr1);
+    lsa0->AddLinkRecord(lr2);
+    lsa0->AddLinkRecord(lr3);
+    m_lsasv6.push_back(lsa0);
+
+    // router 1
+    auto lr4 =
+        new GlobalRoutingLinkRecord<Ipv6Manager>(GlobalRoutingLinkRecord<Ipv6Manager>::PointToPoint,
+                                                 "::ffff:0.0.0.0",
+                                                 "2001:1::200:ff:fe00:2",
+                                                 "fe80::200:ff:fe00:2",
+                                                 1);
+    auto lr5 =
+        new GlobalRoutingLinkRecord<Ipv6Manager>(GlobalRoutingLinkRecord<Ipv6Manager>::StubNetwork,
+                                                 "2001:1::200:ff:fe00:1",
+                                                 Ipv6Address(buf),
+                                                 1);
+
+    auto lr6 =
+        new GlobalRoutingLinkRecord<Ipv6Manager>(GlobalRoutingLinkRecord<Ipv6Manager>::PointToPoint,
+                                                 "::ffff:0.0.0.3",
+                                                 "2001:3::200:ff:fe00:7",
+                                                 "fe80::200:ff:fe00:7",
+                                                 1);
+    auto lr7 =
+        new GlobalRoutingLinkRecord<Ipv6Manager>(GlobalRoutingLinkRecord<Ipv6Manager>::StubNetwork,
+                                                 "2001:3::200:ff:fe00:8",
+                                                 Ipv6Address(buf),
+                                                 1);
+
+    auto lsa1 = new GlobalRoutingLSA<Ipv6Manager>();
+    lsa1->SetLSType(GlobalRoutingLSA<Ipv6Manager>::RouterLSA);
+    lsa1->SetStatus(GlobalRoutingLSA<Ipv6Manager>::LSA_SPF_NOT_EXPLORED);
+    lsa1->SetLinkStateId("::ffff:0.0.0.1");
+    lsa1->SetAdvertisingRouter("::ffff:0.0.0.1");
+    lsa1->SetNode(nodes.Get(1));
+    lsa1->AddLinkRecord(lr4);
+    lsa1->AddLinkRecord(lr5);
+    lsa1->AddLinkRecord(lr6);
+    lsa1->AddLinkRecord(lr7);
+    m_lsasv6.push_back(lsa1);
+
+    // router 2
+    auto lr8 =
+        new GlobalRoutingLinkRecord<Ipv6Manager>(GlobalRoutingLinkRecord<Ipv6Manager>::PointToPoint,
+                                                 "::ffff:0.0.0.0",
+                                                 "2001:2::200:ff:fe00:6",
+                                                 "fe80::200:ff:fe00:6",
+                                                 1);
+    auto lr9 =
+        new GlobalRoutingLinkRecord<Ipv6Manager>(GlobalRoutingLinkRecord<Ipv6Manager>::StubNetwork,
+                                                 "2001:2::200:ff:fe00:5",
+                                                 Ipv6Address(buf),
+                                                 1);
+    auto lr10 =
+        new GlobalRoutingLinkRecord<Ipv6Manager>(GlobalRoutingLinkRecord<Ipv6Manager>::PointToPoint,
+                                                 "::ffff:0.0.0.3",
+                                                 "2001:4::200:ff:fe00:3",
+                                                 "fe80::200:ff:fe00:3",
+                                                 1);
+    auto lr11 =
+        new GlobalRoutingLinkRecord<Ipv6Manager>(GlobalRoutingLinkRecord<Ipv6Manager>::StubNetwork,
+                                                 "2001:4::200:ff:fe00:4",
+                                                 Ipv6Address(buf),
+                                                 1);
+
+    auto lsa2 = new GlobalRoutingLSA<Ipv6Manager>();
+    lsa2->SetLSType(GlobalRoutingLSA<Ipv6Manager>::RouterLSA);
+    lsa2->SetStatus(GlobalRoutingLSA<Ipv6Manager>::LSA_SPF_NOT_EXPLORED);
+    lsa2->SetLinkStateId("::ffff:0.0.0.2");
+    lsa2->SetAdvertisingRouter("::ffff:0.0.0.2");
+    lsa2->SetNode(nodes.Get(2));
+    lsa2->AddLinkRecord(lr8);
+    lsa2->AddLinkRecord(lr9);
+    lsa2->AddLinkRecord(lr10);
+    lsa2->AddLinkRecord(lr11);
+    m_lsasv6.push_back(lsa2);
+
+    // router 3
+    auto lr12 =
+        new GlobalRoutingLinkRecord<Ipv6Manager>(GlobalRoutingLinkRecord<Ipv6Manager>::PointToPoint,
+                                                 "::ffff:0.0.0.1",
+                                                 "2001:3::200:ff:fe00:8",
+                                                 "fe80::200:ff:fe00:8",
+                                                 1);
+    auto lr13 =
+        new GlobalRoutingLinkRecord<Ipv6Manager>(GlobalRoutingLinkRecord<Ipv6Manager>::StubNetwork,
+                                                 "2001:3::200:ff:fe00:7",
+                                                 Ipv6Address(buf),
+                                                 1);
+    auto lr14 =
+        new GlobalRoutingLinkRecord<Ipv6Manager>(GlobalRoutingLinkRecord<Ipv6Manager>::PointToPoint,
+                                                 "::ffff:0.0.0.2",
+                                                 "2001:4::200:ff:fe00:4",
+                                                 "fe80::200:ff:fe00:4",
+                                                 1);
+    auto lr15 =
+        new GlobalRoutingLinkRecord<Ipv6Manager>(GlobalRoutingLinkRecord<Ipv6Manager>::StubNetwork,
+                                                 "2001:4::200:ff:fe00:3",
+                                                 Ipv6Address(buf),
+                                                 1);
+
+    auto lsa3 = new GlobalRoutingLSA<Ipv6Manager>();
+    lsa3->SetLSType(GlobalRoutingLSA<Ipv6Manager>::RouterLSA);
+    lsa3->SetStatus(GlobalRoutingLSA<Ipv6Manager>::LSA_SPF_NOT_EXPLORED);
+    lsa3->SetLinkStateId("::ffff:0.0.0.3");
+    lsa3->SetAdvertisingRouter("::ffff:0.0.0.3");
+    lsa3->SetNode(nodes.Get(3));
+    lsa3->AddLinkRecord(lr12);
+    lsa3->AddLinkRecord(lr13);
+    lsa3->AddLinkRecord(lr14);
+    lsa3->AddLinkRecord(lr15);
+    m_lsasv6.push_back(lsa3);
 }
 
 void
@@ -823,21 +1471,37 @@
     RngSeedManager::SetSeed(1);
     RngSeedManager::SetRun(1);
 
-    BuildLsa();
+    BuildLsav4();
 
     // insert the LSAs into the GlobalRouteManagerLSDB
-    auto srmlsdb = new GlobalRouteManagerLSDB();
-    srmlsdb->Insert(m_lsas[0]->GetLinkStateId(), m_lsas[0]);
-    srmlsdb->Insert(m_lsas[1]->GetLinkStateId(), m_lsas[1]);
-    srmlsdb->Insert(m_lsas[2]->GetLinkStateId(), m_lsas[2]);
-    srmlsdb->Insert(m_lsas[3]->GetLinkStateId(), m_lsas[3]);
+    auto srmlsdbv4 = new GlobalRouteManagerLSDB<Ipv4Manager>();
+    srmlsdbv4->Insert(m_lsasv4[0]->GetLinkStateId(), m_lsasv4[0]);
+    srmlsdbv4->Insert(m_lsasv4[1]->GetLinkStateId(), m_lsasv4[1]);
+    srmlsdbv4->Insert(m_lsasv4[2]->GetLinkStateId(), m_lsasv4[2]);
+    srmlsdbv4->Insert(m_lsasv4[3]->GetLinkStateId(), m_lsasv4[3]);
 
     // create the GlobalRouteManagerImpl
-    auto srm = new GlobalRouteManagerImpl();
-    srm->DebugUseLsdb(srmlsdb);
+    auto srmv4 = new GlobalRouteManagerImpl<Ipv4Manager>();
+    srmv4->DebugUseLsdb(srmlsdbv4);
 
     // we manually call the DebugSPFCalculate to fill the routing tables for node 0
-    srm->DebugSPFCalculate(m_lsas[0]->GetLinkStateId());
+    srmv4->DebugSPFCalculate(m_lsasv4[0]->GetLinkStateId());
+
+    // now for ipv6
+    BuildLsav6();
+
+    // insert the LSAs into the GlobalRouteManagerLSDB
+    auto srmlsdbv6 = new GlobalRouteManagerLSDB<Ipv6Manager>();
+    srmlsdbv6->Insert(m_lsasv6[0]->GetLinkStateId(), m_lsasv6[0]);
+    srmlsdbv6->Insert(m_lsasv6[1]->GetLinkStateId(), m_lsasv6[1]);
+    srmlsdbv6->Insert(m_lsasv6[2]->GetLinkStateId(), m_lsasv6[2]);
+    srmlsdbv6->Insert(m_lsasv6[3]->GetLinkStateId(), m_lsasv6[3]);
+
+    // create the GlobalRouteManagerImpl
+    auto srmv6 = new GlobalRouteManagerImpl<Ipv6Manager>();
+    srmv6->DebugUseLsdb(srmlsdbv6);
+    // we manually call the DebugSPFCalculate to fill the routing tables for node 0
+    srmv6->DebugSPFCalculate(m_lsasv6[0]->GetLinkStateId());
 
     // now the tests-----------------------
 
@@ -851,6 +1515,7 @@
     // assign streams to the UniformRandomVariable
     globalRouting0->AssignStreams(0);
     // check that the correct number of routes were built
+
     uint32_t nRoutes0 = globalRouting0->GetNRoutes();
     NS_TEST_ASSERT_MSG_EQ(nRoutes0, 14, "Error-- incorrect number of routes found on node 0");
 
@@ -894,7 +1559,7 @@
     expectedNextHops.emplace_back("10.1.2.2");
 
     // Test 1: Check the Routing Table of Node 0
-    CheckRoutes(globalRouting0, expectedDests, expectedNextHops);
+    CheckRoutesv4(globalRouting0, expectedDests, expectedNextHops);
 
     // Test 2: Check that the equal cost routes are being used at least once.
     // we need to call RouteOutput() at node 0 and check the output
@@ -903,29 +1568,114 @@
 
     Socket::SocketErrno errno_;
     Ptr<NetDevice> oif(nullptr);
-    Ptr<Packet> packet = Create<Packet>();
+    Ptr<Packet> packetv6 = Create<Packet>();
     Ipv4Header ipHeader;
     ipHeader.SetSource(Ipv4Address("10.1.1.1"));
     ipHeader.SetDestination(Ipv4Address("10.1.4.2"));
 
     for (uint32_t i = 0; i < 10; i++)
     {
-        Ptr<Ipv4Route> route = globalRouting0->RouteOutput(packet, ipHeader, oif, errno_);
-        IncrementCount(route);
+        Ptr<Ipv4Route> route = globalRouting0->RouteOutput(packetv6, ipHeader, oif, errno_);
+        IncrementCountv4(route);
+    }
+
+    // now the tests for IPv6-----------------------
+
+    Ptr<Ipv6L3Protocol> ip0v6 = nodes.Get(0)->GetObject<Ipv6L3Protocol>();
+    NS_TEST_ASSERT_MSG_NE(ip0v6, nullptr, "Error-- no Ipv6 object at node 0");
+    Ptr<Ipv6RoutingProtocol> routing0v6 = ip0v6->GetRoutingProtocol();
+    NS_TEST_ASSERT_MSG_NE(routing0v6, nullptr, "Error-- no Ipv6 routing protocol object at node 0");
+    Ptr<Ipv6GlobalRouting> globalRouting0v6 = routing0v6->GetObject<Ipv6GlobalRouting>();
+    NS_TEST_ASSERT_MSG_NE(globalRouting0v6,
+                          nullptr,
+                          "Error-- no Ipv6GlobalRouting object at node 0");
+
+    // assign streams to the UniformRandomVariable
+    globalRouting0v6->AssignStreams(0);
+    // check that the correct number of routes were built
+    uint32_t nRoutes0v6 = globalRouting0v6->GetNRoutes();
+    NS_TEST_ASSERT_MSG_EQ(nRoutes0v6, 14, "Error-- incorrect number of routes found on node 0");
+
+    // check that the routes are correct
+    std::vector<Ipv6Address> expectedDestsv6;
+    std::vector<Ipv6Address> expectedNextHopsv6;
+
+    // add all the expected destinations and gateways. This is pretty verbose
+    // Please Note: The order of the following line is important because we check the routing table
+    // entries in order. The test will fail if we reorder the vector entries.
+
+    // For Routing table of Node 0 we check the following Destinations and Gateways
+    expectedDestsv6.emplace_back("2001:1::200:ff:fe00:2");
+    expectedDestsv6.emplace_back("2001:3::200:ff:fe00:7");
+    expectedDestsv6.emplace_back("2001:2::200:ff:fe00:6");
+    expectedDestsv6.emplace_back("2001:4::200:ff:fe00:3");
+    expectedDestsv6.emplace_back("2001:3::200:ff:fe00:8");
+    expectedDestsv6.emplace_back("2001:3::200:ff:fe00:8");
+    expectedDestsv6.emplace_back("2001:4::200:ff:fe00:4");
+    expectedDestsv6.emplace_back("2001:4::200:ff:fe00:4");
+    expectedDestsv6.emplace_back("2001:1::");
+    expectedDestsv6.emplace_back("2001:3::");
+    expectedDestsv6.emplace_back("2001:3::");
+    expectedDestsv6.emplace_back("2001:4::");
+    expectedDestsv6.emplace_back("2001:4::");
+    expectedDestsv6.emplace_back("2001:2::");
+
+    expectedNextHopsv6.emplace_back("fe80::200:ff:fe00:2");
+    expectedNextHopsv6.emplace_back("fe80::200:ff:fe00:2");
+    expectedNextHopsv6.emplace_back("fe80::200:ff:fe00:6");
+    expectedNextHopsv6.emplace_back("fe80::200:ff:fe00:6");
+    expectedNextHopsv6.emplace_back("fe80::200:ff:fe00:2");
+    expectedNextHopsv6.emplace_back("fe80::200:ff:fe00:6");
+    expectedNextHopsv6.emplace_back("fe80::200:ff:fe00:2");
+    expectedNextHopsv6.emplace_back("fe80::200:ff:fe00:6");
+    expectedNextHopsv6.emplace_back("fe80::200:ff:fe00:2");
+    expectedNextHopsv6.emplace_back("fe80::200:ff:fe00:2");
+    expectedNextHopsv6.emplace_back("fe80::200:ff:fe00:6");
+    expectedNextHopsv6.emplace_back("fe80::200:ff:fe00:2");
+    expectedNextHopsv6.emplace_back("fe80::200:ff:fe00:6");
+    expectedNextHopsv6.emplace_back("fe80::200:ff:fe00:6");
+    // Test 1: Check the Routing Table of Node 0
+    CheckRoutesv6(globalRouting0v6, expectedDestsv6, expectedNextHopsv6);
+
+    // Test 2: Check that the equal cost routes are being used at least once.
+    // we need to call RouteOutput() at node 0 and check the output
+    // route from the table. The thing to check here is that different equal cost routes are
+    // returned across different calls to this method.
+
+    Ptr<Packet> packet = Create<Packet>();
+    Ipv6Header ipHeaderv6;
+    ipHeaderv6.SetSource(Ipv6Address("2001:1::200:ff:fe00:1"));
+    ipHeaderv6.SetDestination(Ipv6Address("2001:4::200:ff:fe00:4"));
+
+    for (uint32_t i = 0; i < 10; i++)
+    {
+        Ptr<Ipv6Route> route = globalRouting0v6->RouteOutput(packet, ipHeaderv6, oif, errno_);
+        IncrementCountv6(route);
     }
 
     Simulator::Run();
 
     NS_TEST_ASSERT_MSG_GT_OR_EQ(
-        route1,
+        route1v4,
         1,
         "The routing path for node 0 to node 3 does not match the expected output, "
-        "Equal Cost MultiPath (ECMP) routes are not being used correctly");
+        "Equal Cost MultiPath (ECMP) routes are not being used correctly for ipv4");
     NS_TEST_ASSERT_MSG_GT_OR_EQ(
-        route2,
+        route2v4,
         1,
         "The routing path for node 0 to node 3 does not match the expected output, "
-        "Equal Cost MultiPath (ECMP) routes are not being used correctly");
+        "Equal Cost MultiPath (ECMP) routes are not being used correctly for ipv4");
+
+    NS_TEST_ASSERT_MSG_GT_OR_EQ(
+        route1v6,
+        1,
+        "The routing path for node 0 to node 3 does not match the expected output, "
+        "Equal Cost MultiPath (ECMP) routes are not being used correctly for ipv6");
+    NS_TEST_ASSERT_MSG_GT_OR_EQ(
+        route2v6,
+        1,
+        "The routing path for node 0 to node 3 does not match the expected output, "
+        "Equal Cost MultiPath (ECMP) routes are not being used correctly for ipv6");
 
     // end of test--------------------
 
@@ -937,7 +1687,8 @@
     RngSeedManager::SetRun(oldrun);
     // This delete clears the srm, which deletes the LSDB, which clears
     // all of the LSAs, which each destroys the attached LinkRecords.
-    delete srm;
+    delete srmv4;
+    delete srmv6;
 }
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/test/ipv4-address-helper-test-suite.cc ns-3.47/src/internet/test/ipv4-address-helper-test-suite.cc
--- ns-3.46/src/internet/test/ipv4-address-helper-test-suite.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/test/ipv4-address-helper-test-suite.cc	2026-02-16 16:08:49.623230000 -0800
@@ -94,7 +94,6 @@
 void
 AddressAllocatorHelperTestCase::DoRun()
 {
-    Ipv4Address network;
     Ipv4Address address;
     Ipv4AddressHelper h;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/test/tcp-abe-test.cc ns-3.47/src/internet/test/tcp-abe-test.cc
--- ns-3.46/src/internet/test/tcp-abe-test.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.47/src/internet/test/tcp-abe-test.cc	2026-02-16 16:08:49.625230000 -0800
@@ -0,0 +1,270 @@
+/*
+ * Copyright (c) 2025 NITK Surathkal
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Authors: N Nagabhushanam    <thechosentwins2005@gmail.com>
+ *          Namburi Yaswanth   <yaswanthnamburi1010@gmail.com>
+ *          Vishruth S Kumar   <vishruthskumar@gmail.com>
+ *          Yashas             <yashas80dj@gmail.com>
+ *          Mohit P. Tahiliani <tahiliani@nitk.edu.in>
+ */
+#include "ns3/log.h"
+#include "ns3/tcp-cubic.h"
+#include "ns3/tcp-linux-reno.h"
+#include "ns3/tcp-socket-state.h"
+#include "ns3/test.h"
+
+namespace ns3
+{
+NS_LOG_COMPONENT_DEFINE("TcpAbeTestSuite");
+
+constexpr uint32_t WITHOUT_ABE = 0; //!< Test case without ABE
+constexpr uint32_t WITH_ABE = 1;    //!< Test case with ABE
+
+/**
+ * @ingroup internet-test
+ * @brief Test Socket Base class for ABE testing
+ *
+ * This class provides access to the TCP socket state and allows
+ * manipulation of ECN state for testing purposes.
+ */
+class TestTcpSocketBase : public TcpSocketBase
+{
+  public:
+    /**
+     * @brief Get the pointer for socket state
+     * @return ptr to TcpSocketState
+     */
+    Ptr<TcpSocketState> GetTcb() const
+    {
+        return m_tcb;
+    }
+
+    /**
+     * @brief Set the ECE state for testing ECN behavior
+     */
+    void SetECE()
+    {
+        m_tcb->m_ecnState = TcpSocketState::ECN_ECE_RCVD;
+    }
+};
+
+/**
+ * @ingroup internet-test
+ * @brief Checks if users are able to enable ABE or not.
+ **/
+
+class TcpAbeToggleTest : public TestCase
+{
+  protected:
+    Ptr<TestTcpSocketBase> m_socket; //!< Socket used for testing
+
+  public:
+    /**
+     * @brief Constructor
+     * @param desc Test case description
+     */
+    TcpAbeToggleTest(const std::string& desc)
+        : TestCase(desc)
+    {
+    }
+
+    /**
+     * @brief Runs the test
+     */
+    void DoRun() override
+    {
+        NS_LOG_FUNCTION(this);
+        m_socket = CreateObject<TestTcpSocketBase>();
+        m_socket->SetUseAbe(true);
+        NS_TEST_EXPECT_MSG_EQ(m_socket->GetTcb()->m_abeEnabled, true, "ABE should be enabled");
+        NS_TEST_EXPECT_MSG_EQ(m_socket->GetTcb()->m_useEcn,
+                              true,
+                              "ECN should be enabled along with ABE");
+
+        m_socket->SetUseAbe(false);
+        NS_TEST_EXPECT_MSG_EQ(m_socket->GetTcb()->m_abeEnabled, false, "ABE should be disabled");
+    }
+};
+
+/**
+ * @ingroup internet-test
+ * @brief Test case for congestion control algorithms with ABE
+ *
+ * This test verifies that when a TCP socket has ABE enabled, the congestion
+ * window value returned by its GetSsThresh() method will be calculated using
+ * the default BetaEcn value, and when ABE is disabled, the standard
+ * multiplicative decrease by half is used.
+ * ABE should only work for TcpCubic, TcpNewReno, TcpLinuxReno as specified in
+ * RFC-8511
+ */
+class TcpAbeTest : public TestCase
+{
+  private:
+    uint32_t testCase;        //!< Test case number
+    uint32_t m_segmentSize;   //!< Segment size
+    uint32_t m_initialCwnd;   //!< Initial congestion window
+    uint32_t m_expectedCwnd;  //!< Expected congestion window after applying Beta(BetaLoss)/BetaEcn
+    uint32_t m_bytesInFlight; //!< Bytes in flight
+    TypeId m_congestionControlType;  //!< TypeId of the congestion control algorithm type used for
+                                     //!< the test
+    Ptr<TestTcpSocketBase> m_socket; //!< Socket used for testing
+
+  public:
+    /**
+     * @brief Constructor
+     * @param desc Test case description
+     * @param testCase Test case identifier (0 for without ABE, 1 for with ABE)
+     * @param segmentSize Segment size
+     * @param initialCwnd Initial congestion window
+     * @param expectedCwnd Expected congestion window after applying Beta(BetaLoss)/BetaEcn
+     * @param bytesInFlight Bytes in flight
+     * @param congestionControlType TypeId of the congestion control algorithm type used for the
+     * test
+     */
+    TcpAbeTest(uint32_t testCase,
+               uint32_t segmentSize,
+               uint32_t initialCwnd,
+               uint32_t expectedCwnd,
+               uint32_t bytesInFlight,
+               TypeId& congestionControlType,
+               const std::string& desc)
+        : TestCase(desc),
+          testCase(testCase),
+          m_segmentSize(segmentSize),
+          m_initialCwnd(initialCwnd),
+          m_expectedCwnd(expectedCwnd),
+          m_bytesInFlight(bytesInFlight),
+          m_congestionControlType(congestionControlType)
+    {
+        NS_LOG_FUNCTION(this << desc);
+    }
+
+    /**
+     * @brief Runs the test
+     */
+    void DoRun() override
+    {
+        NS_LOG_FUNCTION(this);
+        m_socket = CreateObject<TestTcpSocketBase>();
+        ObjectFactory congestionAlgorithmFactory;
+        congestionAlgorithmFactory.SetTypeId(m_congestionControlType);
+        Ptr<TcpCongestionOps> algo = congestionAlgorithmFactory.Create<TcpCongestionOps>();
+        m_socket->SetCongestionControlAlgorithm(algo);
+
+        if (testCase == WITH_ABE)
+        {
+            m_socket->SetUseAbe(true);
+            m_socket->SetECE();
+            m_socket->GetTcb()->m_segmentSize = m_segmentSize;
+            m_socket->GetTcb()->m_cWnd = m_initialCwnd;
+            m_socket->GetTcb()->m_bytesInFlight = m_bytesInFlight;
+            uint32_t newCwnd = algo->GetSsThresh(m_socket->GetTcb(), m_bytesInFlight);
+            NS_TEST_EXPECT_MSG_EQ(
+                newCwnd,
+                m_expectedCwnd,
+                m_congestionControlType.GetName() +
+                    " congestion control with ABE should apply BetaEcn correctly");
+        }
+        else if (testCase == WITHOUT_ABE)
+        {
+            m_socket->SetUseAbe(false);
+            m_socket->SetECE();
+            m_socket->GetTcb()->m_segmentSize = m_segmentSize;
+            m_socket->GetTcb()->m_cWnd = m_initialCwnd;
+            m_socket->GetTcb()->m_bytesInFlight = m_bytesInFlight;
+            uint32_t newCwnd = algo->GetSsThresh(m_socket->GetTcb(), m_bytesInFlight);
+            NS_TEST_EXPECT_MSG_EQ(
+                newCwnd,
+                m_expectedCwnd,
+                m_congestionControlType.GetName() +
+                    " congestion control without ABE should apply Beta correctly");
+        }
+        else
+        {
+            NS_TEST_EXPECT_MSG_EQ(0, 1, "Invalid test case");
+        }
+        Simulator::Destroy();
+        m_socket = nullptr;
+    }
+};
+
+/**
+ * @ingroup internet-test
+ * @brief Test suite for Alternative Backoff with ECN (ABE)
+ *
+ * This test suite verifies the behavior of TCP ABE with different
+ * congestion control algorithms.
+ */
+class TcpAbeTestSuite : public TestSuite
+{
+  public:
+    /**
+     * @brief Constructor
+     */
+    TcpAbeTestSuite()
+        : TestSuite("tcp-abe-test", Type::UNIT)
+    {
+        AddTestCase(new TcpAbeToggleTest("Test enabling and disabling ABE"),
+                    TestCase::Duration::QUICK);
+
+        TypeId cong_control_type = TcpCubic::GetTypeId();
+        AddTestCase(new TcpAbeTest(WITHOUT_ABE,
+                                   1,
+                                   1000,
+                                   700,
+                                   100,
+                                   cong_control_type,
+                                   "Test TCP CUBIC without ABE"),
+                    TestCase::Duration::QUICK);
+        AddTestCase(new TcpAbeTest(WITH_ABE,
+                                   1,
+                                   1000,
+                                   850,
+                                   100,
+                                   cong_control_type,
+                                   "Test TCP CUBIC with ABE"),
+                    TestCase::Duration::QUICK);
+
+        cong_control_type = TcpLinuxReno::GetTypeId();
+        AddTestCase(new TcpAbeTest(WITHOUT_ABE,
+                                   1,
+                                   1000,
+                                   500,
+                                   100,
+                                   cong_control_type,
+                                   "Test TCP Linux Reno without ABE"),
+                    TestCase::Duration::QUICK);
+        AddTestCase(new TcpAbeTest(WITH_ABE,
+                                   1,
+                                   1000,
+                                   700,
+                                   100,
+                                   cong_control_type,
+                                   "Test TCP Linux Reno with ABE"),
+                    TestCase::Duration::QUICK);
+
+        cong_control_type = TcpNewReno::GetTypeId();
+        AddTestCase(new TcpAbeTest(WITHOUT_ABE,
+                                   1,
+                                   1000,
+                                   500,
+                                   1000,
+                                   cong_control_type,
+                                   "Test TCP New Reno without ABE"),
+                    TestCase::Duration::QUICK);
+        AddTestCase(new TcpAbeTest(WITH_ABE,
+                                   1,
+                                   1000,
+                                   700,
+                                   1000,
+                                   cong_control_type,
+                                   "Test TCP New Reno with ABE"),
+                    TestCase::Duration::QUICK);
+    }
+};
+
+static TcpAbeTestSuite g_tcpAbeTestSuite; //!< static var for test initialization
+
+} // namespace ns3
